#include "syntaxparser.hh"
#include "parser.hh"

#include <iostream>

#include "bitbuf.hh"

static Syntax *parser;

static string fgetsstringtrans(const char *s)
{
	string q(s);
	for(;;)
	{
		unsigned b = q.find('\r');
		if(b == q.npos) { b = q.find('\n');
		if(b == q.npos) break; }
		q.erase(b);
	}
	return q;
}

static void Decompress(const string &s)
{
//	string t = BitBuf(s).Decompress();
//	cout << t << endl;
	cout << s << endl;
}
static string Compress(const string &s)
{
//	return BitBuf(s).Compress();
	return s;
}

void Load(const char *s)
{
	parser = new Syntax(s);
}

int Encoded(const char *s)
{
	const char *q = rivitunniste;
	while(*s && *q)
		if(*q++ != *s++)return 0;
	return *q ? 0 : 1;
}
int Decode(const char *s)
{
	s += strlen(rivitunniste);
	int result = *parser - fgetsstringtrans(s);
	
	Decompress(parser->getresult());
	
	return result;
}
int Encode(const char *s)
{
	int result = *parser + Compress(fgetsstringtrans(s));
	cout << rivitunniste << parser->getresult() << endl;
	return result;
}
void Unload()
{
	delete parser;
	parser = NULL;
}
